<?php

namespace Drupal\commerce_vb_md;

use Drupal\commerce_order\Entity\OrderInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Session\AccountProxyInterface;
use Drupal\Core\Url;

class VictoriaBankBackRefHandler{

  protected EntityTypeManagerInterface $entityTypeManager;

  protected VictoriaBankManager $victoriaBankManager;

  protected AccountProxyInterface $currentUser;

  public function __construct(EntityTypeManagerInterface $entityTypeManager, VictoriaBankManager $victoriaBankManager, AccountProxyInterface $account) {
    $this->entityTypeManager = $entityTypeManager;
    $this->victoriaBankManager = $victoriaBankManager;
    $this->currentUser = $account;
  }

  public function redirect(OrderInterface $order): Url{
    $currentUser = \Drupal::currentUser();
    $frontUrl = Url::fromRoute("<front>");
    $access = $order->access('view', $currentUser);

    if(!$access){
      return $frontUrl;
    }
    if(!$order->isLocked()){
      sleep(1);
    }
    //Back url is access if user fail or success payment.
    //It must always back to payment page or next checkout step id.
    return Url::fromRoute('commerce_checkout.form', [
      'commerce_order' => $order->id()
    ]);
  }

}
